## smpq 1.5

=== CMakeLists.txt ===
#
#    CMakeLists.txt - cmake for StormLib MPQ archiving utility
#    Copyright (C) 2010 - 2012  Pali Rohár <pali.rohar@gmail.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#

project(SMPQ)
set(VERSION 1.5)
cmake_minimum_required(VERSION 2.6)

option(WITH_CMD "Enable smpq console application" ON)
option(WITH_KDE "Enable KDE4 kio_smpq plugin" ON)

if(WIN32)
	option(WITH_NSIS "Create Windows NSIS Installer" OFF)
endif(WIN32)

if(NOT STORMLIB_INCLUDE_DIR OR NOT STORMLIB_LIBRARY)

	find_path(STORMLIB_INCLUDE_DIR StormLib.h)
	find_library(STORMLIB_LIBRARY NAMES StormLib storm)

	if(NOT STORMLIB_INCLUDE_DIR)
		message(FATAL_ERROR "StormLib.h header file not found")
	endif(NOT STORMLIB_INCLUDE_DIR)

	if(NOT STORMLIB_LIBRARY)
		message(FATAL_ERROR "StormLib or storm library not found")
	endif(NOT STORMLIB_LIBRARY)

	try_compile(CHECK ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/check.c COMPILE_DEFINITIONS -I${STORMLIB_INCLUDE_DIR})

	if(NOT CHECK)
		message(FATAL_ERROR "Found old StormLib version")
	endif(NOT CHECK)

	message(STATUS "Found StormLib header: ${STORMLIB_INCLUDE_DIR}/StormLib.h")
	message(STATUS "Found StormLib library: ${STORMLIB_LIBRARY}")

	mark_as_advanced(STORMLIB_INCLUDE_DIR STORMLIB_LIBRARY)

endif(NOT STORMLIB_INCLUDE_DIR OR NOT STORMLIB_LIBRARY)

include_directories(${STORMLIB_INCLUDE_DIR})

add_definitions(-DVERSION="${VERSION}")

set(SMPQ_SRCS
	append.c
	extract.c
	info.c
	listfiles.c
	main.c
	print.c
	remove.c
	rename.c
)

if(MSVC)

	set(SMPQ_SRCS
		${SMPQ_SRCS}
		dirname.c
	)

endif(MSVC)

set(MANGEN_SRCS
	mangen.c
)

set(KIO_SMPQ_SRCS
	kio_smpq.cpp
)

set(SMPQ_NSIS
	${CMAKE_CURRENT_SOURCE_DIR}/smpq.nsi
)

if(WITH_CMD)

	add_executable(smpq ${SMPQ_SRCS})
	target_link_libraries(smpq ${STORMLIB_LIBRARY})

	if(WIN32 AND NOT MSVC)
		set_target_properties(smpq PROPERTIES LINK_FLAGS -static)
	endif(WIN32 AND NOT MSVC)

	install(TARGETS smpq DESTINATION bin)

	if(NOT CMAKE_CROSSCOMPILING)

		add_executable(mangen ${MANGEN_SRCS})
		add_custom_command(OUTPUT smpq.1 COMMAND mangen > smpq.1 DEPENDS mangen)
		add_custom_target(man ALL DEPENDS smpq.1)

		install(FILES ${CMAKE_CURRENT_BINARY_DIR}/smpq.1 DESTINATION share/man/man1)

	endif(NOT CMAKE_CROSSCOMPILING)

	if(WIN32 AND WITH_NSIS)

		find_package(SelfPackers REQUIRED)

		if(NOT MAKENSIS)

			find_program(MAKENSIS makensis)

			if(NOT MAKENSIS)
				message(FATAL_ERROR "makensis not found")
			else(NOT MAKENSIS)
				message(STATUS "Found makensis: ${MAKENSIS}")
			endif(NOT MAKENSIS)

			mark_as_advanced(MAKENSIS)

		endif(NOT MAKENSIS)

		if(CMAKE_SIZEOF_VOID_P STREQUAL 4)

			set(MAKENSIS_OUTPUT SMPQ-${VERSION}.exe)

		else(CMAKE_SIZEOF_VOID_P STREQUAL 4)

			set(MAKENSIS_FLAGS -DX86_64 ${MAKENSIS_FLAGS})
			set(MAKENSIS_OUTPUT SMPQ-${VERSION}-x86_64.exe)

		endif(CMAKE_SIZEOF_VOID_P STREQUAL 4)

		if(NOT CMAKE_VERBOSE_MAKEFILE)
			set(MAKENSIS_FLAGS -V2 -DQUIET ${MAKENSIS_FLAGS})
		endif(NOT CMAKE_VERBOSE_MAKEFILE)

		set(MAKENSIS_FLAGS ${MAKENSIS_FLAGS} -DUPX="${SELF_PACKER_FOR_EXECUTABLE}" -DVERSION="${VERSION}" -NOCD)

		file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/COPYING DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
		file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/README DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

		if(CMAKE_SIZEOF_VOID_P STREQUAL 4)
			add_custom_command(TARGET smpq POST_BUILD
				COMMAND ${SELF_PACKER_FOR_EXECUTABLE}
				ARGS ${SELF_PACKER_FOR_EXECUTABLE_FLAGS} -qq -9 smpq${CMAKE_EXECUTABLE_SUFFIX}
			)
		endif(CMAKE_SIZEOF_VOID_P STREQUAL 4)

		add_custom_command(OUTPUT ${MAKENSIS_OUTPUT} COMMAND ${MAKENSIS} ARGS ${MAKENSIS_FLAGS} ${SMPQ_NSIS} DEPENDS smpq smpq.nsi COPYING)
		add_custom_target(installer ALL DEPENDS ${MAKENSIS_OUTPUT})

	endif(WIN32 AND WITH_NSIS)

endif(WITH_CMD)

if(WITH_KDE)

	find_package(KDE4 REQUIRED)
	include(KDE4Defaults)

	set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR})
	set_target_properties(KDE4__kdecore PROPERTIES IMPORTED_LINK_INTERFACE_LIBRARIES_DEBIAN "Qt4::QtCore")
	set_target_properties(KDE4__kio PROPERTIES IMPORTED_LINK_INTERFACE_LIBRARIES_DEBIAN "KDE4__kdecore")

	include_directories(${KDE4_INCLUDES})

	set(CMAKE_REQUIRED_INCLUDES "${CMAKE_REQUIRED_INCLUDES};${QT_INCLUDE_DIR}")
	check_symbol_exists(Q_OS_UNIX "QtCore/qglobal.h" Q_OS_UNIX)

	if(NOT Q_OS_UNIX)
		add_definitions(-DKDEDIR=${CMAKE_INSTALL_PREFIX})
	endif(NOT Q_OS_UNIX)

	kde4_add_plugin(kio_smpq ${KIO_SMPQ_SRCS})
	target_link_libraries(kio_smpq ${STORMLIB_LIBRARY} ${KDE4_KIO_LIBS})

	install(TARGETS kio_smpq DESTINATION ${PLUGIN_INSTALL_DIR})
	install(FILES smpq.protocol DESTINATION ${SERVICES_INSTALL_DIR})
	install(FILES smpq.xml DESTINATION ${XDG_MIME_INSTALL_DIR})

endif(WITH_KDE)

=== debian/changelog ===
smpq (1.5-1) unstable; urgency=low

  * Initial release (Closes: #633931)

 -- Pali Rohár <pali.rohar@gmail.com>  Fri, 29 Jul 2016 00:03:25 +0200

=== debian/control ===
Source: smpq
Section: utils
Priority: optional
Maintainer: Pali Rohár <pali.rohar@gmail.com>
Build-Depends: debhelper (>= 9), cmake, libstorm-dev (>= 9.20), kdelibs5-dev
Standards-Version: 3.9.8
Homepage: https://launchpad.net/smpq
Vcs-Bzr: lp:smpq
Vcs-Browser: https://code.launchpad.net/smpq

Package: smpq
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: StormLib MPQ archiving utility
 SMPQ is StormLib MPQ archiving utility. This utility is designed for full
 manipulating with Blizzard MPQ archives. It supports extracting, appending,
 renaming and deleting files in MPQ archives. It also can create MPQ archive.
 SMPQ can access to different type of MPQ archives and version. It support
 encrypted, compressed, partial and patched MPQ archives with version 1-4.
 SMPQ is free opensource command line utility written in C/C++ which use
 multiplatform C++ StormLib library.

Package: kio-smpq
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: KDE4 kio plugin for StormLib MPQ archiving utility
 This is KDE4 KIO plugin which add support for all KDE4 applications
 (e.g. Konqueror, Dolphin, Kate, ... and all KDE4 open/save dialogs) access to
 MPQ archives like to directory or network drive (or FTP). This is simple way
 how to integrate MPQ support on KDE4 desktop (There is no need to use some MPQ
 viewer/editor. All KDE4 application can open MPQ archives in read/write mode).
 .
 This plugin is part of SMPQ. But it does not depend on SMPQ application binary.

## smpq 1.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,7 @@
 #
 
 project(SMPQ)
-set(VERSION 1.5)
+set(VERSION 1.6)
 cmake_minimum_required(VERSION 2.6)
 
 option(WITH_CMD "Enable smpq console application" ON)
@@ -97,6 +97,7 @@
 
 	if(WIN32 AND NOT MSVC)
 		set_target_properties(smpq PROPERTIES LINK_FLAGS -static)
+		target_link_libraries(smpq wininet stdc++)
 	endif(WIN32 AND NOT MSVC)
 
 	install(TARGETS smpq DESTINATION bin)
@@ -148,6 +149,7 @@
 
 		file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/COPYING DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
 		file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/README DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
+		file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/CHANGELOG DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
 
 		if(CMAKE_SIZEOF_VOID_P STREQUAL 4)
 			add_custom_command(TARGET smpq POST_BUILD
@@ -156,7 +158,7 @@
 			)
 		endif(CMAKE_SIZEOF_VOID_P STREQUAL 4)
 
-		add_custom_command(OUTPUT ${MAKENSIS_OUTPUT} COMMAND ${MAKENSIS} ARGS ${MAKENSIS_FLAGS} ${SMPQ_NSIS} DEPENDS smpq smpq.nsi COPYING)
+		add_custom_command(OUTPUT ${MAKENSIS_OUTPUT} COMMAND ${MAKENSIS} ARGS ${MAKENSIS_FLAGS} ${SMPQ_NSIS} DEPENDS smpq smpq.nsi COPYING README CHANGELOG)
 		add_custom_target(installer ALL DEPENDS ${MAKENSIS_OUTPUT})
 
 	endif(WIN32 AND WITH_NSIS)

=== debian/changelog ===
smpq (1.6-2) unstable; urgency=medium

  * Update Standards-Version to 4.1.5
  * Update to debhelper 11
  * Update watch and signing-key.asc
  * Enable LFS support
  * Use https links in copyright
  * Drop KDE4 package kio-smpq (Closes: #875182)

 -- Pali Rohár <pali.rohar@gmail.com>  Sun, 08 Jul 2018 13:06:31 +0200

smpq (1.6-1) unstable; urgency=low

  * New upstream release 1.6
  * Fix license name from GPL-3.0+ to GPL-3+
  * Update upstream signing-key
  * Bump compat level to 10
  * Stop installing README file

 -- Pali Rohár <pali.rohar@gmail.com>  Tue, 13 Dec 2016 02:00:23 +0100

=== debian/control ===
Source: smpq
Section: utils
Priority: optional
Maintainer: Pali Rohár <pali.rohar@gmail.com>
Build-Depends: debhelper (>= 11~), cmake, libstorm-dev
Standards-Version: 4.1.5
Homepage: https://launchpad.net/smpq
Vcs-Bzr: lp:smpq
Vcs-Browser: https://code.launchpad.net/smpq

Package: smpq
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: StormLib MPQ archiving utility
 SMPQ is StormLib MPQ archiving utility. This utility is designed for full
 manipulating with Blizzard MPQ archives. It supports extracting, appending,
 renaming and deleting files in MPQ archives. It also can create MPQ archives.
 SMPQ can access different types and versions of MPQ archives. It supports
 encrypted, compressed, partial and patched MPQ archives in version 1-4.
 SMPQ is free opensource command line utility written in C which uses
 multiplatform C++ StormLib library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+lfs

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DWITH_KDE=OFF

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ https://launchpad.net/smpq/+download https://launchpad.net/smpq/trunk/([0-9\.]+)/\+download/smpq.*\.tar\.gz debian uupdate
